""" pyWiewAnim.py -- Class to display animations in pyWiew#
    Copyright (C) 2003-2004 Anand B Pillai <abpillai@lycos.com> """

import Image
import time, threading
import pyWiewGlobals
from wxPython.wx import *

class pyWiewAnimation(threading.Thread):

    def __init__(self, img):

        threading.Thread.__init__(self, None, None, "Animation")
        self._im=img
        self._ff=self._im.copy()
        self._index=0
        self._seqlen=0
        self._flag=0
        self._finishflag=0
        self._drwframe=None
        self._gap=0

    def nextframe(self):

        self._index += 1
        try:
            if self._index:
                try:
                    self._im.seek(self._index)
                except ValueError:
                    return None
                except IOError:
                    return None
            return self._im
        except EOFError:
            print 'End of sequence...'
            self._seqlen=self._index
            raise IndexError

    def firstframe(self):
        return self._ff

    def IsAnimation(self):

        anim=1
        try:
            #try seeking to next frame
            self._im.seek(1)
        except EOFError:
            anim=0

        return anim

    def SetDuration(self, val):
        """Time gap between frames"""
        self._gap=val

    def SetImageFrame(self, wdow):
        self._drwframe=wdow

    def run(self):

        while self._finishflag==0:
            #get next frame
            time.sleep(float(self._gap)/1000.0)
            #suspended!
            if self._flag:
                continue
            try:
                self.nextframe()
                #get image
                if self._im:
                    try:
                        img=pyWiewGlobals.PilImgTowxImg(self._im)
                    except IOError, AttributeError:
                        continue
                    self._drwframe.SetDisplayImage(img)
                    self._drwframe.DrawImage()
                else:
                    continue

            except IndexError:
                break

        #reset
        print 'resetting...'
        self._index=0
        self._flag=0

        print 'resetting menus...'
        self._drwframe.ProcessAnimationEvents(None)

    def RewindAnimation(self):
        self._im=self._ff.copy()
        self._index=0
        img=pyWiewGlobals.PilImgTowxImg(self._im)
        self._drwframe.SetDisplayImage(img)
        self._drwframe.DrawImage()

    def RestartAnimation(self):
        self._flag=0

    def SuspendAnimation(self):
        #stop animation
        #drop flag
        self._flag=1

    def SpeedUpAnimation(self):
        """ Increase speed of animation """

        #decrease gap by 50 milliseconds
        self._gap -= 50.0

    def SlowDownAnimation(self):
        """ Decrease speed of animation """

        #increase gap by 50 milliseconds
        self._gap += 50.0

    def GotoLastFrame(self):

        while 1:
            try:
                self.nextframe()
            except IndexError:
                break

        img=pyWiewGlobals.PilImgTowxImg(self._im)
        self._drwframe.SetDisplayImage(img)
        self._drwframe.DrawImage()              

    def end(self):
        print 'Ending animation thread'
        self._finishflag=1
        self._drwframe=None




