""" pyWiewGlobals.py --- File containing global function/data definitions for pyWiew application#
    Copyright 2002-2003 Anand B Pillai <abpillai@Lycos.com> """

import sys,os
import zlib
import array
import math
import StringIO, cStringIO
import threading, thread
import Image
from wxPython.wx import *

Image._initialized = 1

##Begin global data##
ABOUT_TEXT = """PyWiew:
      An Imageviewer/editor written in wxPython using Python Imaging Library(PIL).
      PyWiew is totally free software released under the GNU LGPL License.
      For licensing information, visit http://www.gnu.org/copyleft/lgpl.html

      Author: Anand B Pillai
      Copyright (C) 2003-2004,  Anand B Pillai

      Visit the Python Chamber at http://members.fortunecity.com/anandpillai
      """


NO_IMAGE_ERROR='No Image Loaded'
CAPTION_FRAME ='PyWiew'
DW = 480
DH = 450
# maximum number of images in an album row
MAXROWS = 5
# maximum number of entries in the MRUDS list
MAXMRUD = 5
##End global data##

URLEVENTOK=1400
URLEVENTERROR=1401
ANIMNOTIFEVENT=1976
ANIMATIONCOMPL=0
ANIMATIONERR=-1

def Min(x, y):
      if x < y:
            return x
      elif y <= x:
            return y
      
def pyWiewTrace(data):
      try:
            print data
      except IOError:
            pass
      
def cyclicxor(data):
      """ Weak xor cyclic encryption of the passed data.
      Data should be an ascii or utf-8 encoded string. The
      algorithm cyclically xors  the characters, using the
      result of nth xor operation as key for n+1th xor
      operation.The key for the first xor operation is the
      ascii value for the length of the string"""

      encoded=""

      k=chr(len(data))
      enc=data[0] ^ k
      encoded += str(enc)

      x=1
      key=enc
      while x<len(data)-1:
            c=data[x]
            enc=c ^ key
            encoded += str(enc)

            #set value of new key
            key = enc





##Begin globals functions##
def getCloseData():
      return \
'\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00\x0b\x00\x00\x00\x0e\x08\x06\
\x00\x00\x00\xf9a\xe6\x95\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\
\x00\x01\nIDATx\x9cm\x91\xa1\xae\xc2@\x10EO\t\xa2\xf2!++\x91X\x14A"\xa9\xec\
\'\xb4\x86T\xf6\x1bV\xeeW\x90\xf0\t\r\xeaY\x1c+W\x8e\\\\\xc7\x15\xd1\xd7%}e\
\x92M&\x93\xb3wf\xee$\xf7\xfb}\x00\xb8^\xaft]\xc7\xffp\xce\xc5|=%\xd6Z\x86a@\
U\x17\x1f\x00D\x84\xd5\xe5r\x89\x05Ue\xbf\xdf#"\x8b\xe7\xbd\'\t?\xe9p\xcc\
\xb7<\x1e\x0fv\xbb\x1d\x9dwd\n\xcf\xe7s&""$}\xdb\x0ej\r\xc7|K\xe7\xc7\xf92\
\x85\xb2,#\xdc4\xcd8\x86ZCZ5\xfc\x9eN\xa4U\x13\xc1\xb6m#8\xc5\xea\xdb2\xe7\
\xf3y\x01\x02\xac\xd3j,L\x1d$\x85\xac(\x16cD\xeb\xd4\x1a6/%X3S\xcf\xf3|\xa6\
\xbcRk\xc8\xfe\xac\xdd\xbc>\x1e\xdfn\xb7\x99\x1b\x00\xc9t\xc1\xc3\xe1@\xdf\
\xf7\xd4u\x1d[\x1b3v\xaa\xaa\x8a\x10\xc2\x12\xf6\xde/\x14\x01B\x08\x9fs\x03x\
\xef\x11\x91o\x06\xe1\x9c\x9b\xc3EQ|\x05\xa7x\x03\x7f\xc1\x96=\x1fD\'\xc5\
\x00\x00\x00\x00IEND\xaeB`\x82' 

def getSaveData():
      return \
 '\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00\r\x00\x00\x00\x0e\x08\x06\
\x00\x00\x00\xf4\x7f\x96\xd2\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\
\x00\x00\x00\xcaIDATx\x9c\x9d\x901\x12\x820\x10E\x1f\x8e\x05\xa5t\xd4\x94\
\x94\x1e\xc1\xd6\xda\xd2\x13\xe4\x08X\xea1\xac,\x1d\xaf!\x9d\x966\x0c\x94\
\xa1\x83.\xe9\xd6\x02P2\x0e\x88\xfe\x99\xcc$?\xfb\xf2w\x83\x98D\x94Rb\x8c\
\x19]J)\x11\x93\x88T\x88\'\x15\xe2\x05\x90\xe79c\x8a\xa2\x08\xb9\x81\xb7\x84\
\xd9he+k\xads\x9eO-\xect\xbd\x0c$\r\x01\x1fI\xdf\n\xfb\x9a4\xd3`R\x1c\xc7?@\
\x16D\x03\xa6\xe7\xda\xf1}\x93\xd4\x02\xbbcB]\x96\xce\xab\x8b0d\xbf>8\x9e\'9\
\xd2\x01A\x10\xbc.\x8a\xc7\xc3\x05W\r\x98\xd6\xbd\x99\xea\xb2t \x80\xcdv\x0b\
\xc0\xf9tr\xfc\xff~/\xbd\xb7\xedh\r\xbe\xffnOk\xb2,{\xed\xd3\xba\xf5\x0bx\
\x02\t\xe5p\xdb\xd5k\xa3\x1e\x00\x00\x00\x00IEND\xaeB`\x82'

def getCutData():
      return \
'\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00\x10\x00\x00\x00\x11\x08\x06\
\x00\x00\x00\xd4\xaf,\xc4\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\
\x00\x00\xc9IDATx\x9c\xa5\x931\x0e\xc20\x0cE_P\x07\xae\x82\xc4Ro\xdd<s\x158\
\x06\x12\xd72K\xba\xa5c\x8f\xd1\x9d%\x0cmJ\x0b\x91Z\x11O\x1e\xe2\xe7\xffm\
\xc7\x99Y\xa4 \x0e%\xc5Y\x80\xaa\xa2\xaae\nB\x08\xbb!\xc5\x16*`\xd5\xcd\xcc\
\x10\x11B\x08\x88\x08fF\xee\xcd\n\x00\x10c\xa4\xeb:Dd\xd5aY\x18}\x03C\x8bS\
\x9d!U":\xe7\x80\xd1?@]\xd7s~\xf4\xc2I\x1an\xf7\x96\xeb%ca)+)H\x16\xa2o\xe8\
\x81>\xfc\x16\xaf\x00KP\x92\x1d}\xc3\xf3\xf5\x80\xf3\xf7\x9bO\x9e\xddB\x1a\
\xe4\x9e\xd8\\\xe3\xd6=d\x01\xaaJ\xf4\xe3\xd0\xfeW0\xe4\x87\xf6\x1d?C\x84i\
\xad\x93\xf4\xe5\xd1\xec\x06\xec)LQ\xfc\x17\xde6\x11S=\x1f\x1e\xc1w\x00\x00\
\x00\x00IEND\xaeB`\x82' 

def getUndoData():
      return \
'\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00\x0f\x00\x00\x00\r\x08\x06\
\x00\x00\x00v\x1e4A\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\x00\
\x00\xb9IDATx\x9c\xa5\x92\xcb\r\xc3 \x10Dg-\x1aH\t)!\xa9`\xa5\xdcR\x87\xbb\
\xe0\x9c.\xdc\x81\xef\xdc"M\x05\xb8\x04\x97\xe0\x126\x07\xc0\xc1\xb2\xad eN|\
\xf6\xcd\xc0\x82\x904d\xa9*H\xa2U]\x19\x8c\xe3\x08\x8b\x1e\xaa\xda\x0c\xbb\
\x92h\xd1\x03\xcb\xd4\x0c\x02\x80\x00\xb0\x1a\x94G\xd8\x15\x9d]E,z;M\xbc\xdc\
R\xd1\xfduh\x94\x92\xdf\xcf4\x9b\x03\xa4\xff\xb2\xebz6\xa9\x8dH\xc2\x91\x84\
\xa8\xc2\x86\xfd1%7\xcf\x86\x00\\\x93\x91E\x9fM4u\x9b\xe4&\xb16Y\xf7\xe6\xdc\
\x8be\x02bJ\x97\xd6w\xd6\xeat\xd2\xe7\xc0\x1a\xfe\xa5\xf2\x07J\x80k\x05k\xa8\
\xa8;.k\xd3_\xf0\x07\x8c\x97Wh\xa1\x7ff\xe4\x00\x00\x00\x00IEND\xaeB`\x82' 

def getRedoData():
      return \
 '\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00\x10\x00\x00\x00\x0f\x08\x06\
\x00\x00\x00\xedsO/\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\x00\
\x00\xb9IDATx\x9c\xcd\x92-\x0e\xc2@\x10\x85\xbf%\\\x02\xcb\r\xe8\t&\xbdRe5\
\x12Y\x87E\xed\x1d\x9a\xe7p\xc5\x81\xab\xc5\xe2\x90E\x90i\xfa\x9bP0<\xb3\xc9\
\xce\xfb\xde\xceL6Hj\xf8A\xab%f3\xfb> \xc6\xc8\xe9~\x1c\x85|\x1cP\x14\x05\
\xc0(d=\x07L\xb5\x0bp}\xde\xde!\x1bCR? \xc6\xd8{i\n\xf63\xadvXb\x04I\x8d\x83\
]\xc8\xcd\xfb\xed\xa1\xbd\xcb\xeb\x0c\x80\xf3\xa3\xa4L.H"\x00\x8d\x83\x0e\
\xb9\x01@R;R^g=\xb8\xb7\x83!\xec\x86\xae\xa6jARcf\xa4\xd5\x0e`\x16\xf6.\x86\
\xb5\xe0?\xd1\xb7>\x07\xcf\xa9\x1da)\xe8Z\xf4\x95\xff3\xe0\x05\xcd\xb8r\x01\
\xc9[\xd4A\x00\x00\x00\x00IEND\xaeB`\x82' 

def getCopyData():
      return \
  '\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00\x10\x00\x00\x00\x0f\x08\x06\
\x00\x00\x00\xedsO/\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\x00\
\x00\xa0IDATx\x9c\xa5\x93\xeb\r\xc3 \x0c\x84\xcfQ\x06\xb8Q\xbbA\xe9\x06\x1d\
\xd5\x1b\\\x7f$$\x06\x9c\xd2*\'Y\xe2\x11\x7fp\x87b$qG+\x00\xb8\xbb\xb2M\x926\
\x03,u \xa9\xa9o\xe0\x14\x90I\xd2\x14b$\xe1\xee\x92\x043;\x1a\xb7qI\x9b\xc8\
\xb7\x85\t\xf7\x9eQ@I\xd7\x80"\x92 \xd9Z0\xb3\xa6\xae\xad=\xe1\xfe\xd0\x90A\
\x16d\x04\x9f\xf3\x17\x00l\x90h\x01@W\xa3\x85\xde\xce_7\xc8\xec-\xbf|\xd4\
\x83#|\xdd_"M\xcc\x1d\xaa\xf01H\x9d\x80\x99\xe2\x89\xbd\xa6\x80\x9a\xf8\xe5\
\xfe\xdd\xbf\xf1\x03\x16I\xb2g\xed\xda\x9d\xf6\x00\x00\x00\x00IEND\xaeB`\x82\
'
def getNewData():
      return \
  '\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00\x10\x00\x00\x00\x0f\x08\x06\
\x00\x00\x00\xedsO/\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\x00\
\x00VIDATx\x9cc\x14\x10\x10`\xa0\x04\xb0 s>|\xf8\xf0\x1f\x9fb\x01\x01\x01Ft1\
&t\x81\xff\xff\xffc\xc5\xb8,\xc00\x00\x1f\xf8\xff\xff?\x86!$\x19\xc0\xc8\xc8\
\x88\xe1\x12\x16\x9c\xaa\xb1\xd8\x8en\x10\xc9.\xc0\x06F\r\x18\x0c\x06`\xa4\
\x03\xe48&\x060R\x9a\x1b\x01\x8c\xda\'\xe1O\x8fN\x08\x00\x00\x00\x00IEND\xae\
B`\x82'

def getOpenData():
      return \
  '\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00\x10\x00\x00\x00\x0f\x08\x06\
\x00\x00\x00\xedsO/\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\x00\
\x00\x8eIDATx\x9c\xa5\x92\xd1\r\xc4 \x0cC\x9dS\x07\xf0\xc8\x8c\xec\r\xd2\x0f\
\x14\x91p\xa8W8\xff@\x10\xcf8(F\x12\xff\xe8z{Q\x92\xc7\x9e\xa4m\x19H\xf2\x0c\
E-\xc9\xed\xb4\x85Ht\xcd\x07s\xc4\'\x18\x00\x8c$$\xb9;\x008\x00\x83=\xe0\xb3\
y\xfa\x83\x0e\x03\x0ew+u\xac\xb6p\xfe\x8c\xed\x1a\xaa\xeb\xb7\x96\tF\x1b\x01\
\r8\xf7?\x19T\xb8\xb5\xe5\x83E\xad\x95\x16\xba\xf1\x0eL\xd2J\x82]\x18H\tN` \
\xcd\xc1o\xb4k\x9e\x83\xe3Q\x0e\xdd\x02GB\xf5\xdfU\xf9\x02\x00\x00\x00\x00IE\
ND\xaeB`\x82'

def getPasteData():
      return \
  '\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00\x10\x00\x00\x00\x0f\x08\x06\
\x00\x00\x00\xedsO/\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\x00\
\x00\xa3IDATx\x9c\xa5\x93\xeb\r\xc30\x08\x84\x8f\xaa\x03\\6\xed\x06\xa1\x1bt\
T6\xb8\xfeH\xdc\xe0G\x1eUN\xb2\x84\xc1|`$\x8c$\xee\xe89rF\x84\xf2\x9d\xa4\
\xed\x01\x8cd\x97\x00\x00Z=6H\xcd@\x03 w\xff\x05\xdd\x1d\xd2\x96X\xec\xf6M\
\x81<2\xb9\x04\xa6\x89F.\xa7\xd8\x19\x90\xd5\xcd`\xf4\x9d#U\x80\xbd*\x97\x01\
5\xec&\x00\x00\xa4\xb9\xf3\x99\xbd\x018\x80\x0f\x80f\x88W%\xcd\x88x\xe9\xb4\
\x83\xadb\xddQ\xf6\x9d\x02\xdao\xb4\x90\xbf:\x18B\xd7eR\x7f\\G\x02\\$\x97\
\x0eF\xcb\x12\x01\x8d\xaa\xb7\xfa\x02\x84v]\xe1M7\xf1\xfc\x00\x00\x00\x00IEN\
D\xaeB`\x82'

def getStartupImgData():
      return \
  '\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00 \x00\x00\x00 \x08\x06\x00\
\x00\x00szz\xf4\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\x00\x00qID\
ATx\x9c\xed\xd6;\n\x800\x10E\xd1{\xc5\x8d\xb9r\x97\x16\x0b\xad$\x8a\x82:\x16\
o\xda\x84pB2\x1f\x81Fa\x8c\x9c\x08\x04Z{\xcf\xa72\xbcv\xfa\xc5\x08 \x80r\x80\
\xfc\xa2\x0e\x1c\xe4\xba\xfaX\x1d\xd0\xde]S\x07\x02\xd8>\xe1wa-`\x9fQ\xe9\
\x86\x01\x04\x10\x00\\(Dk\x1b-\x04\xdc\x1d\x07\x14\x98;\x0bS\x7f\x7f\xf9\x13\
\x04\x10@\xf9X\xbe\x00\xc9 \x14K\xab a\xf0\x00\x00\x00\x00IEND\xaeB`\x82' 

def getNextData():
      return \
   '\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00 \x00\x00\x00 \x08\x06\x00\
\x00\x00szz\xf4\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\x00\x00jID\
ATx\x9c\xed\xd01\x0e\xc00\x08\x03@R\xe5a<\xdd?k\xd7*C \x12\x0e\x8bY\x91\xf0\
\xe1\x01\xe0\xb5\xc6yvK\x87\xf7\x02n B\x00\x1b\x91\x020\x11\xf3\xe4\xb8\xc3\
\r\x8eR@\xba\x81?\xa2\x15P\xdd\xc0\xdc\x1d]\xbf\xad\x0e7;h\x80\x11\x9e\x06\
\xb0\xc2S\x00fx\x08`\x87\x87\x80\x1b#\x80\x00\x02\x08 \x80\x00\x02\x08 \xc0\
\x07\'\xb7\x1b\x83{\xd5\xec\x82\x00\x00\x00\x00IEND\xaeB`\x82'

def getPrevData():
      return \
   '\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00 \x00\x00\x00 \x08\x06\x00\
\x00\x00szz\xf4\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\x00\x00qID\
ATx\x9c\xed\xd4\xd1\r\xc0 \x08\x04Pl:\x18\xa3\xdffu\x00\x8bb\xcc\xe1\xcf\xf1\
mr\x0fT\x1a\x80\xcf.\xd6\x939\xe4\xf0{\x00f\xf8\x12\xc0\x0e\x9f\x02*\xc2\xcd\
\xcc\xdelx\x04\x82\xe3\x080L\xa0\xaa\xf3\x10p\xda\xd1n\xfd^\x01\x1c\xc3$X\
\xb0\xf0\x11VMb\xfa\r+\x10\xcbE\xc4F\xa4V1\x13\x91\x020K\x00\x01\x04\x10@\
\x00\x01\x04\x10@\x80\x0e|\xb7\x1b\x83\xa1e_[\x00\x00\x00\x00IEND\xaeB`\x82'\

def getZoominData():
      return \
 '\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00\x14\x00\x00\x00\x13\x08\x06\
\x00\x00\x00\x90\x8c-\xb5\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\
\x00\x00\xb2IDATx\x9c\xad\x93]\x0e\x04!\x08\x83\x99\xc9\x1e\xacG\xe3h\xbd\
\xd9\xee\x83\xc1 \xe2\xcf\x1a\x9b\xcc\x83d\xfc\xac\x15\x1e\x92_\xb9\xa8\xf7&\
l\x08$)\x00\x9a\x8f\xe4\x16\xf0\x13\x0b\x00*t\xa7>u\x08@T5\xddDRT\xb5\x82\
\x97@\x83\xf8\r\x00\x05\xa0[\xaf]V\xe0\xc8\xd9\xc8\xe9H]\x86\xe6,[\x93X\x1ex\
\xbdmR\x87\xe6\xe4\x1fg\xa6&\xc3\xd5\x0b\x96C0\xcd\xf0\xf5?\x167l\x9czwY\'D=\
q\x96W\x8d\x1d\xe1Q]\x86$\xeb\xe8yY$V\x07\x98f\xdb9\xdcQy,\x15\x11\xed\xa0Gm\
S \x05\x18{\xf6\xb8\x0f=\xd4\xeb\xe8\xca3]\x9f\x94\x1f\x13\x85f\xa7\x9b>\xf4\
\xbf\x00\x00\x00\x00IEND\xaeB`\x82' 

def getZoomoutData():
      return \
  '\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00\x13\x00\x00\x00\x12\x08\x06\
\x00\x00\x00\xb9\x0c\xe5i\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\
\x00\x00\xa2IDATx\x9c\xad\x93Q\x0e\x800\x08C\x99\xf1`=\x1aG\xeb\xcd\xf4ca\
\x99\x1b\x83e\xb1\x89?\x04\x9f\x15J!\xf9\xc8O\xba\xbc"I\x01\xf0yH\xa6\xb0{,\
\x00h\xc0\x9d\xfa\xd2\x19\x00QU\xf7\x05\x92\xa2\xaa\r\x1a\xc2\x0c\x105g\xee\
\x8a-`w.Q\xef4\xb3\xda\xecCI\x84\x1fq\xb7y*\xd7Y\xe6`\xa5\xe6,\xdb\x94\xc96\
\x1e\xc2vr\x94m\xbc\x8c\xe7\x94\x85v\x04\xf7\x9afF\xb2\x9dS/\x1b\x83\xd5\x01\
N\xb3\x9d\x9c\xed\xa8FGED?\xc0\xa3hT@\x85\xf5\x99<\xceY\x0f4\x1d\xfd\xe6J\
\xbf^\xc0\x0bZ\x8c^#^\x0c2\xde\x00\x00\x00\x00IEND\xaeB`\x82'

def getBulbLightedData():
      return \
'\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00\x13\x00\x00\x00\x13\x08\x06\
\x00\x00\x00rP6\xcc\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\x00\
\x04\x1bIDATx\x9cM\x8dO\x88\x1bu\x1c\xc5?\xbf\x99\xdf\xccd&\x9bd6\xc9\xfeu\
\xffu]\xd6\x15*\x14\xb1]D\\-\xc5C\xf1 \xda\x9bB\x0fE\xbc\xda\x93 x\x11\xf1&x\
U\xe9\xa1\xea\xadP\xb0\x87R(E(\xd8\x7f\xdb\xd2n\xabR[[\xba\xad\xadM7\xbb\xd9\
d\x92L\x92\xf9\xf7\xf5\xb0\x07\xfb.\xef}\x1e<\x9er\xad\xa6\xf4\xe3\x14e\xfad\
i\x13U\xb4\x91`\x03\xbb<M\xd4\xeac\x90\xc7$%Nk@\x82_\x9c\xa4\x19\x04\xa0\x1c\
\xb4k\x91\xa5m\\\xc7\xa6\x1b40zqL\xc1\xf3\xc9\xd2\x01f\xae\x80\x04\x1b0\xe4\
\x125\x1eA\x1a"Y\x03\xad7\x99\x99\xb6\x80\x1a\x96\xdd\x01:(\xd3 \t{\xd8V\x8e\
np\x87\xb1\x89y\x8c\x9cY%\x08{(l\xd2~\x80\xca+\n^\x8c\xe39\xf8%A\xf3\x80,\
\xb9\xc6\xa3\x7f\x8es\xfd\xc6\xeb\x84\xe1-\xd6\xd6vaH\x06\x86G\xd4\x8f\xb1\
\xddE\x1a\x8d6@_l\x1d\x8beoHn\xe8\xbe\x9c\xbf"\xa2\xf3\xbf\n\x9c\x16\xcd\xcf\
27\xf3\x8d\xc0;\x02/\xca\xdc\xe2\x11\x19\xf6\xbf\x138#\xe3U\x11\xd8\x14X\x97\
\x7f\x9e\x88\xc0c\xc1sD\xe0\x81\xc0\ta\xe8\xb8\x8cL\x9d\x96\xdf.\x88L\x8d\
\x1f\x17m\xbc+k\x7f\x9d\x92\xcd\xe4{\xb9[\xffR\xd6\xb7\xce\x0b\x1c\x94\xd1\
\xe29\x192k\xa2\xe9\x8bc\xf7\x04\x1e\x8a\xeb\xa6\xa2\xa0-\xa8:w\x1f\xeebe\
\xe5\x17j\xeb\x7fP\xf2\x07\xcc\xcd\xd49\xf6\xe3\xfb\xec\xdes\x9d>\xab\x08\
\x06\xcd\xedy\x8a\xfa(3\x13\x9f\xa39\x84\xd6\xfbh\xb4blg\x9441PXO\xc5\xd6&Q\
\xaf\x8ec\xb7(\x16\xfe$S\xa7\xb8x\xed0\xe3/\xdcF\x06\x0fA\xb5\xc8y\x06\x9d(%\
\xb5Gh\xb5\xf6\xb18\xf9\x03y\xe7\x13T\xfa6\x9d\xc0\x03|\x0c\xad5\xa0\xd1\xc6\
(\x92X\\\xbe\xf41\xcd\xe6mJ\x95u$\xbb\x81I\x03[\x84\xac\xa70\xa4G\xc4*~\xe96\
\xa8\x9b\\\xb8x\x84Nw\x8b\x91\x91q \xc6H\x93\x12Q\xaf\xc3\xc5\xd5*f\xee\x19\
\x07\xf6\x1f#M\x04\x95i,m\x00M\xb2\xa4C\xd2s(9K\xe8x\x9e\xda3\x07d\x9a\xe5\
\xbd\xdfb\x1a.\xf5\xfa\x06\x86\xcac(,\x94.\xf1\xc6\xca\x1d\xb4e\xd3\xd8\xee\
\x01.9\xbbB\x1c+\x0c\xcb _\x1a\xc6t\x84\xda\xb3\x1a\xe035\xf6\x1a\x84\x13\
\xa4\xe14\x8e]"\x9f\x1f\xc5\xf3\x0ct\x16\'`\xba\xc4\xe1(1\r\\\xab\xcc\xfc\
\xfc2\xcd\x8e"_,\x12\rZ(\xb3N7\x8b\xc8U|\xcaz\x96Kw\xb6\xf0\x8b\xef\xd1\x0b\
\xf6\x12vSP\x01\x88\xc60s\x1a\xd2\x10+\x97261\xc9\xe5\xab\x1f\xd1\xd8vY\x98;\
L\xd4\x7f\x15\xdbY`@\x1e\xaf\xe0\x93*\x9f\xd5{)o-\x7f\x81\x0c\x96\xf0\xecY\
\xca\xa5Y \x06bt\xda\x7fDe\xaa\xcc\xd6\xe3\xd3\x9c<\xfb!\xcbo\xfeD\x14N05\
\xfe\x19\x8d\x7f\x0f\x11\x8f\xa4\xd8\xc5\x98\x08!\xea\xbe\xc2\xae\xeaQr\x83a\
l\xbd\xc4f\xb7\x89D!\x00\xe3\x13\x15\xc0\xdc\x12\x9c\xbf\xc5\xac\x9e\x13c\
\xf8\x84x\x95\xb3\xb2vK\xc45O\xca\xe2\xc2\xd7b\xfa\xc8\x93\xe8+\xb9\xdf9*xH\
\xde\xfaTF\xdd\xdf\xc5\xb7\x03\x81\x9a\\\xbe"R\x1dK\x04n\x8a\xae\x8e\x96\xd9\
|\x1a\x92\xa6/a\xe64ag\x93\x03+\x1d\xfa\xe9\x1e\xee\xdf\xab\x93\x9a\x16I:K?\
\xce \x03\x83\x971\xd5\x12\xcd\xe8\t\xd5\xe2,\xfb\xf7\xb7\xe8\x85\x1bxC\x0b\
\x00O\xc5rE\xb4#\x02\r\xc9\xe7E\xa0#\x06\xa1\x94\xfd\xab\x02+\x12\x88H \x9bB\
a\xb7x\xd6\x19\xd1t\xc45D\xa0+v\xae-\xf0X\xb4\xd5\x16\xadT\x99\xb8\x9f\x00\n\
\xf0\t\xbb)J)P!A\xcf\x02\x0e\xd2\x0b!N*\xd0\xfe\x80\xc4\x99\x04\x95\xd0\xcb\
\xda\xe4\x9c\x02\x83A\x04F\x85$1P\x8aD\x00\xc0\xd812P\x030;`\x048^\x9f~\xd4\
\xc2q\x1c\x06\xed\x8c\xfc\xd0,\xdd\xa6\xc2\xb6G\x88\xa2\xec\xb9\x1d\x18;\xf0\
\x7f\xb1\x935d\x0ed\x1eI\xe4@h3he\x14J\x93t\x9b\xdb\x18\xa6G\x9a\xc8\xce\xf1\
s\xfa\x0f!\xf1\x0c\x8d\xca\x02\xe0\xed\x00\x00\x00\x00IEND\xaeB`\x82' 

def getBulbDimmedData():
      return \
 '\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00(\x00\x00\x00(\x08\x06\x00\
\x00\x00\x8c\xfe\xb8m\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\x00\
\x00\xd4IDATx\x9c\xed\xd8Q\x0b\xc20\x0c\x04\xe0\x8b\xf8\xff\xffr}\x90\x80\
\xcc\xea\x9a\xbb\xcc\x96\x9a{\x1cc|\xa4]\x9a\xcd\x80\xd6\xb0pn\xb3\x01g)\xa0\
\x9a\x02\xaa\xb9\xe7=\xca:\xd7\xf4\x06\x91\x00|\xc2Z\xa7[\x999\x9a\x87\x9a\
\xd6\x07\xad\x0b{\xbb\xcb\x0c,R\xd8\x83c8\xc0\xab\xdb\xdb\x02\xe7!\x81\xe38\
\x0f\x8b$\x80q\x9c\x87A\x06\x81<\xce\x13E.\xdf\x07w\x02\xea\xcb\xeb\x89,\xf3\
N\x15\x9c\x93\x02\xaa\t\x00\xdb\xcb\xe1\xaf%r6\xefT\xc19\t\x02\xf5e\x8e\x8e^\
D\x05y$3\x17\x92K\x1cG\xb2C\xab\xb0\x07\xc7\x91\x93&j`\x04\xa9\xe0\x80\x94\
\xb7\xf83R\xc5\x01\xfb\xb5\x99\xdf\'\xed\xc3=\xeb\x18<&\r\xf8\xfd\xc3\x9dOUP\
\xcd\xbfT\xf0\xba\xdf\xdc\xcb\xb7\x99\x02\xaay\x00\xa3w@k\xad(\xcb\xf8\x00\
\x00\x00\x00IEND\xaeB`\x82' 

def getBulbLightedBitmap():
      stream=cStringIO.StringIO(getBulbLightedData())
      return wxBitmapFromImage(wxImageFromStream(stream))
def getBulbDimmedBitmap():
      stream=cStringIO.StringIO(getBulbDimmedData())
      return wxBitmapFromImage(wxImageFromStream(stream))

def getCopyBitmap():
      stream=cStringIO.StringIO(getCopyData())
      return wxBitmapFromImage(wxImageFromStream(stream))

def getOpenBitmap():
      stream=cStringIO.StringIO(getOpenData())
      return wxBitmapFromImage(wxImageFromStream(stream))
def getPasteBitmap():
      stream=cStringIO.StringIO(getPasteData())
      return wxBitmapFromImage(wxImageFromStream(stream))

def getNewBitmap():
      stream=cStringIO.StringIO(getNewData())
      return wxBitmapFromImage(wxImageFromStream(stream))
def getStartupBitmap():
      stream = cStringIO.StringIO(getStartupImgData())
      return wxBitmapFromImage(wxImageFromStream(stream))

def getNextBitmap():
      stream = cStringIO.StringIO(getNextData())
      return wxBitmapFromImage(wxImageFromStream(stream))
def getPrevBitmap():
      stream = cStringIO.StringIO(getPrevData())
      return wxBitmapFromImage(wxImageFromStream(stream))

def getZoomoutBitmap():
      stream = cStringIO.StringIO(getZoomoutData())
      return wxBitmapFromImage(wxImageFromStream(stream))
def getZoominBitmap():
      stream = cStringIO.StringIO(getZoominData())
      return wxBitmapFromImage(wxImageFromStream(stream))

def getCloseBitmap():
      stream = cStringIO.StringIO(getCloseData())
      return wxBitmapFromImage(wxImageFromStream(stream))
def getSaveBitmap():
      stream = cStringIO.StringIO(getSaveData())
      return wxBitmapFromImage(wxImageFromStream(stream))

def getCutBitmap():
      stream = cStringIO.StringIO(getCutData())
      return wxBitmapFromImage(wxImageFromStream(stream))
def getUndoBitmap():
      stream = cStringIO.StringIO(getUndoData())
      return wxBitmapFromImage(wxImageFromStream(stream))

def getRedoBitmap():
      stream = cStringIO.StringIO(getRedoData())
      return wxBitmapFromImage(wxImageFromStream(stream))

def wxImgToPILImg(img):
      if img is None:
            return None
      else:
            try:
                  pimg= Image.fromstring("RGB", wxSize(img.GetWidth(), img.GetHeight()), img.GetData())
                  print 'Got it babe!'
                  print pimg
                  return pimg
            except:
                  print 'Exception !'
                  return None

def PilImgTowxImg(pimg):

      if not pimg:
            return None
      else:

            img = apply( wxEmptyImage, pimg.size ) 
            img.SetData( pimg.convert( "RGB").tostring() )

            return img

def ImgOfSize(size, col,depth=32):
      """ Return a wxImage instance of given size and given fill-color """

      #img=apply(wxEmptyImage, size)
      w,h=size[0],size[1]
      #set the color
      _rgbsz = w*h
      r,g,b=col.Red(), col.Green(), col.Blue()
      collist=[]
      for x in range(0,_rgbsz):
            collist.extend([r,g,b])
      arr=array.array('B',collist)
      str=arr.tostring()
      if depth == 32:
            bmap=wxEmptyBitmap(w,h)
      else:
            bmap=wxEmptyBitmap(w,h,depth)
            print 'Depth =', bmap.GetDepth()

      img=wxImageFromBitmap(bmap)
      img.SetData(str)

      return img

def TestPilStatus():

      img = ImgOfSize((16,16), wxColour(255,255,255))
      pimg = wxImgToPILImg(img)
      if pimg is None:
            return FALSE
      else:
            return TRUE

def PILReadDict():

      dic = { ".bmp" : "BMP",
              ".dib" : "BMP",
              ".cur" : "CUR",
              ".dcx" : "DCX",
              ".fli" : "FLI",
              ".flc" : "FLI",
              ".fpx" : "FPX",
              ".gbr" : "GBR",
              ".gd"  : "GD",
              ".gif" : "GIF",
              ".ico" : "ICO",
              ".im"  : "IM",
              ".imt" : "IMT",
              ".jpg" : "JPEG",
              ".jpeg" : "JPEG",
              ".jpe" : "JPEG",
              ".mic" : "MIC",
              ".mcidas" : "MCIDAS",
              ".msp" : "MSP",
              ".pcd" : "PCD",
              ".pcx" : "PCX",
              ".png" : "PNG",
              ".ppm" : "PPM",
              ".pnm" : "PPM",
              ".pbm" : "PPM",
              ".psd" : "PSD",
              ".bw" :  "SGI",
              ".cmyk" : "SGI",
              ".rgb" : "SGI",
              ".ras" : "SUN",
              ".tga" : "TGA", 
              ".tif" : "TIFF",
              ".tiff" : "TIFF",
              ".xpm" : "XPM",
              ".xbm" : "XBM"
              }

      return dic

def PILWriteDict():

      dic = {  ".bmp": "BMP",
               ".eps": "EPS",
               ".gif": "GIF",
               ".im" : "IM",
               ".jpg" : "JPEG",
               ".msp" : "MSP",
               ".pcx" : "PCX",
               ".pdf" : "PDF",
               ".png" : "PNG",
               ".ppm" : "PPM",
               ".tif" : "TIFF",
               ".xbm" : "XBM"
            }

      return dic

def wxReadDict():

      dic = { ".ani" : wxBITMAP_TYPE_ANI,
              ".bmp" : wxBITMAP_TYPE_BMP,
              ".cur" : wxBITMAP_TYPE_CUR,
              ".dib" : wxBITMAP_TYPE_BMP,
              ".jpg" : wxBITMAP_TYPE_JPEG,
              ".jpeg" : wxBITMAP_TYPE_JPEG,
              ".jpe" : wxBITMAP_TYPE_JPEG,
              ".gif" : wxBITMAP_TYPE_GIF,
              ".ico" : wxBITMAP_TYPE_ICO,
              ".tiff" : wxBITMAP_TYPE_TIF,
              ".tif" : wxBITMAP_TYPE_TIF ,
              ".pcx" : wxBITMAP_TYPE_PCX,
              ".png" : wxBITMAP_TYPE_PNG,
              ".ppm" : wxBITMAP_TYPE_PNM,
              ".pnm" : wxBITMAP_TYPE_PNM,
              ".pbm" : wxBITMAP_TYPE_PNM,
              ".xpm" : wxBITMAP_TYPE_XPM,
              "": wxBITMAP_TYPE_ANY
              }

      return dic

def wxWriteDict():

      dic = { ".bmp" : wxBITMAP_TYPE_BMP,
              ".cur" : wxBITMAP_TYPE_CUR,
              ".dib" : wxBITMAP_TYPE_BMP,
              ".jpg" : wxBITMAP_TYPE_JPEG,
              ".ico" : wxBITMAP_TYPE_ICO,
              ".tif" : wxBITMAP_TYPE_TIF ,
              ".pcx" : wxBITMAP_TYPE_PCX,
              ".png" : wxBITMAP_TYPE_PNG,
              ".ppm" : wxBITMAP_TYPE_PNM,
              ".xpm" : wxBITMAP_TYPE_XPM,
              }

      return dic

def AllImagesTuples():
      """ List of image file types/ description tuples """

      d = [] 
      d.append(("BMP/DIB" , "Windows Bitmap File"))
      d.append(("CUR" , "Windows Cursor File"))
      d.append(("DCX" , "DCX Fax Image"))
      d.append(("FPX" , "Kodak Flashpix Image"))
      d.append(("GBR" , "Gimp Brush File"))
      d.append(("GD"  , "GD Image File"))
      d.append(("GIF" , "Compuserve GIF Image"))
      d.append(("ICO" , "Windows Icon File"))
      d.append(("IM"  , "Labeye (IFUNC) Image"))
      d.append(("IMT" , "Imagetools Image"))
      d.append(("JPG" , "JPEG Image"))
      d.append(("MIC" , "Microsoft Image Composer File"))
      d.append(("MCI" , "MCIDAS Image"))
      d.append(("PCX" , "Macintosh PCX Image"))
      d.append(("PNG" , "Portable Network Graphics Image"))
      d.append(("SGI" , "SGI Image"))
      d.append(("RAS" , "Sun Raster Image"))
      d.append(("TGA" , "Truevision Targa Image"))
      d.append(("XBM" , "XWindows Bitmap Image"))
      d.append(("XPM" , "XWindows Pixmap Image"))

      return d

def AllAnimationsTuples():
      """ List of animation file type/ description tuples """

      d = []
      d.append(("FLI", "Autodesk FLI Animation"))
      d.append(("FLC", "Autodesk FLC Animation"))
      d.append(("ANI", "Windows Animated Cursor"))

      return d

def AllFilesTuples():

      tup = AllImagesTuples()
      tup.extend(AllAnimationsTuples())
      return tup

def wxFileFilterR():

      filter="All Files|*.*|Windows Animated Cursors|*.ani|Windows Bitmap|*.bmp;*.dib|\
Compuserve GIF|*.gif|JPEG Image|*.jpg;*.jpeg;*.jpe|PNG Image|*.png|\
Portable Pixmap Image|*.ppm|Portable Bitmap Image|*.pbm|Portable Graymap Image|*.pgm|\
Portable Anymap Image|*.pnm|Tagged Image File|*.tif;*.tiff"

      return filter

def wxFileFilterW():

      filter="All Files|*.*|Windows Bitmap|*.bmp|\
Compuserve GIF|*.gif|JPEG Image|*.jpg|PNG Image|*.png|\
Portable Pixmap Image|*.ppm|Portable Bitmap Image|*.pbm|Portable Graymap Image|*.pgm|\
Portable Anymap Image|*.pnm|Tagged Image File|*.tiff"

      return filter

def PILFilterR():

      filter="All Files|*.*|Windows Bitmap|*.bmp;*.dib|Windows Cursors|*.cur|\
Fax Image|*.dcx|Autodesk FLI Animation|*.fli|Autodesk FLC Animation|*.flc|\
Kodak Flashpix Image|*.fpx|Gimp Brush Files|*.gbr|GD Image File|*.gd|Compuserve GIF|*.gif|\
Windows Icon File|*.ico|Labeye(IFUNC) Image|*.im|Imagetools Image|*.imt|JPEG Image|*.jpeg;*.jpg;*.jpe|\
Microsoft Image Composer File|*.mic|MCIDAS Image|*.mci;*.mcidas|MSP Images|*.msp|Photo CD Image|*.pdc|\
Macintosh PCX Image|*.pcx|PNG Image|*.png|Portable Pixmap Image|*.ppm|Portable Bitmap Image|*.pbm|Portable Graymap Image|*.pgm|Portable Anymap Image|*.pnm|Tagged Image File|*.tiff;*.tif|Adobe Photoshop Image|*.psd|\
SGI Image|*.rgb;*.cmyk;*.bw|SUN Raster Image|*.ras|Targa Image|*.tga|XWindows Bitmap|*.xbm|\
XWindows Pixmap|*.xpm"

      return filter

def PILFilterW():

      filter="Windows Bitmap|*.bmp|Encapsulated Postscript|*.eps|Compuserve GIF|*.gif|\
Labeye(IFUNC) Image|*.im|JPEG Image|*.jpg|MSP Image|*.msp|Macintosh PCX Image|*.pcx|Adobe PDF Image|\
*.pdf|PNG Image|*.png|PPM Image|*.ppm|Tagged Image File|*.tif|XWindows Bitmap|*.xbm"

      return filter

def AllFilterR():

      filter="All Files|*.*|Windows Bitmap|*.bmp;*.dib|Windows Animated Cursors|*.ani|\
Windows Cursors|*.cur|\
Fax Image|*.dcx|Autodesk FLI Animation|*.fli|Autodesk FLC Animation|*.flc|\
Kodak Flashpix Image|*.fpx|Gimp Brush Files|*.gbr|GD Image File|*.gd|Compuserve GIF|*.gif|\
Windows Icon File|*.ico|Labeye(IFUNC) Image|*.im|Imagetools Image|*.imt|JPEG Image|*.jpeg;*.jpg;*.jpe|\
Microsoft Image Composer File|*.mic|MCIDAS Image|*.mci;*.mcidas|MSP Images|*.msp|Photo CD Image|*.pdc|\
Macintosh PCX Image|*.pcx|PNG Image|*.png|Portable Pixmap Image|*.ppm|Portable Bitmap Image|*.pbm|Portable Graymap Image|*.pgm|Portable Anymap Image|*.pnm|Tagged Image File|*.tiff;*.tif|Adobe Photoshop Image|*.psd|\
SGI Image|*.rgb;*.cmyk;*.bw|SUN Raster Image|*.ras|Targa Image|*.tga|XWindows Bitmap|*.xbm|\
XWindows Pixmap|*.xpm"

      return filter

def AllFilterW():

      filter="Windows Bitmap|*.bmp|Encapsulated Postscript|*.eps|Compuserve GIF|*.gif|\
Labeye(IFUNC) Image|*.im|JPEG Image|*.jpg|MSP Image|*.msp|Macintosh PCX Image|*.pcx|Adobe PDF Image|\
*.pdf|PNG Image|*.png|PPM Image|*.ppm|Tagged Image File|*.tif|XWindows Bitmap|*.xbm"

      return filter

def GraphicFileTypes():

      graphicfiletypes = []
      graphicfiletypes.append('Animated Windows Cursors')
      graphicfiletypes.append('Windows Bitmap Files')
      graphicfiletypes.append('Windows Cursor Files')
      graphicfiletypes.append('Multipage Zsoft Paintbrush')
      graphicfiletypes.append('Kodak Flashpix Image')
      graphicfiletypes.append('Autodesk FLC Animations')
      graphicfiletypes.append('Autodesk FLI Animations')      
      graphicfiletypes.append('Gimp Brush Files')
      graphicfiletypes.append('GD Image File')
      graphicfiletypes.append('Compuserve GIF Image')
      graphicfiletypes.append('Windows Icon File')
      graphicfiletypes.append('Labeye (IFUNC) Image')
      graphicfiletypes.append('Imagetools Image File')
      graphicfiletypes.append('JPEG format')
      graphicfiletypes.append('Microsoft Image Composer File')
      graphicfiletypes.append('Macintosh PCX Image')
      graphicfiletypes.append('Portable Network Graphics Image')
      graphicfiletypes.append('Portable Pixmap Image')
      graphicfiletypes.append('TIFF format')
      graphicfiletypes.append('Adobe Photoshop Image')
      graphicfiletypes.append('SGI Image')
      graphicfiletypes.append('SUN Raster Image')
      graphicfiletypes.append('Targa Image Format')
      graphicfiletypes.append('XWindows Bitmap')
      graphicfiletypes.append('XWindows Pixmap')

      return graphicfiletypes

def GetFileFilterRead():

      if TestPilStatus():
            return AllFilterR()
      else:
            return wxFileFilterR()

def GetFileFilterWrite():

      if TestPilStatus():
            return AllFilterW()
      else:
            return wxFileFilterW()

def FileValidForRead(filename):

      #check if this is a directory first
      if os.path.isdir(filename):
            return FALSE

      fext=(os.path.splitext(filename))[1]
      fext=string.lower(fext)
      dict=None
      dict=wxReadDict()

      found=FALSE
      entry=None

      try:
            entry=dict[fext]
      except:
            pass

      if entry:
            found=TRUE

      if not entry:
            if TestPilStatus():
                  dict=PILReadDict()
                  try:
                        entry=dict[fext]
                  except:
                        pass

                  if entry:
                        found=TRUE

      return found

def FileValidForWrite(filename):

      fext=(os.path.splitext(filename))[1]
      fext=string.lower(fext)
      dict=None
      dict=wxWriteDict()

      found=FALSE

      entry=None
      try:
            entry=dict[fext]
      except:
            pass

      if entry:
            found=TRUE

      if not entry:
            if TestPilStatus():
                  dict=PILWriteDict()
                  try:
                        entry=dict[fext]
                  except:
                        pass

                  if entry:
                        found=TRUE

      return found

def PILGetFormat(filename, flag):

      fext = (os.path.splitext(filename))[1]
      if flag==0:
            dict = PILReadDict()
      else:
            dict = PILWriteDict()

      format=""
      try:
            format=dict[fext]
      except:
            pass

      return format

def wxGetFormat(filename, flag):

      fext = (os.path.splitext(filename))[1]
      if flag==0:
            dict=wxReadDict()
      else:
            dict = wxWriteDict()

      format=""
      try:
            format = dict[fext]
      except:
            pass

      return format

def PILToWxFormat(format):

      if format=="JPEG":
            return wxBITMAP_TYPE_JPEG
      elif format=="BMP":
            return wxBITMAP_TYPE_BMP
      elif format=="PCX":
            return wxBITMAP_TYPE_PCX
      elif format=="PNG":
            return wxBITMAP_TYPE_PNG
      elif format=="PPM":
            return wxBITMAP_TYPE_PNM
      elif format=="TIFF":
            return wxBITMAP_TYPE_TIF
      elif format=="XPM":
            return wxBITMAP_TYPE_XPM
      elif format=="ICO":
            return wxBITMAP_TYPE_ICO
      elif format=="CUR":
            return wxBITMAP_TYPE_CUR
      else:
            return wxBITMAP_TYPE_ANY



class DebugMessageHandler:
      """
            A simple debug error handling class to write debug messages to a text file.
            If you are debugging your python GUI app, you need to either run it using
            the standard python interpreter, or use some tool like IDLE to view the
            debug messages instantly. If you are running it using pythonw, the debug
            messages are lost. This class allows you to write the messages to
            a text file and view them at your convenience later, in such cases.
            """

      def __init__(self, filename=None):
            """ Constructor """
            self._buff = ""
            if filename is None:
                  filename='errors.txt'

            self._fname = filename
            #create a fresh debug file each time
            if os.path.exists(filename):
                  os.remove(filename)

      def write(self, s):
            """ Write the given debug message to a text file """

            if s == '' or ((s[-1] != "\n") and (s[-1] != "\r")):
                  self._buff = self._buff + s
                  return

            try:
                  s = self._buff + s
                  self._buff = ""
                  f = open(self._fname, "a")
                  f.write(s)
                  f.close()
            except:
                  pass # Don't recursively crash on errors. 

#Copied from Eric Westra's pySketch application
class ExceptionHandler:
      """
      A simple error-handling class to write exceptions to a text file.
Under MS Windows, the standard DOS console window doesn't scroll and
closes as soon as the application exits, making it hard to find and
view Python exceptions.  This utility class allows you to handle Python
exceptions in a more friendly manner.
      """

      def __init__(self, filename=None):
            """ Standard constructor.
            """
            self._buff = ""

            if filename is None:
                  filename='errors.txt'

            self._fname = filename
            if os.path.exists(self._fname):
                  os.remove(self._fname)

      def write(self, s):
            """ Write the given error message to a text file.
            Note that if the error message doesn't end in a carriage return, we
            have to buffer up the inputs until a carriage return is received.
            """

            if (s[-1] != "\n") and (s[-1] != "\r"):
                  self._buff = self._buff + s
                  return

            try:
                  s = self._buff + s
                  self._buff = ""
                  if s[:9] == "Traceback":
                        # Tell the user than an exception occurred.
                        wxMessageBox("An internal error has occurred.\nPlease " + \
                                     "refer to the " + "'" + self._fname +  "'" + " file for details.",
                                     "Error", wxOK | wxCENTRE | wxICON_EXCLAMATION)

                  f = open(self._fname, "a")
                  f.write(s)
                  f.close()

            except:
                  pass # Don't recursively crash on errors. 



