""" pyWiewSlideshow.py --- classes for running a slideshow of images for pyWiew
 Copyright 2002-2003 Anand B Pillai <abpillai@Lycos.com> """

import pyWiewGlobals
from wxPython.wx import *
import thread, threading
import time

class pyWiewSlideShowPanel(wxDialog):
	"Slideshow panel for the user"
	
	def __init__(self, parent, W,H):
		wxDialog.__init__(self, parent, wxNewId(), "Slideshow ", wxDefaultPosition, wxSize(W, H), wxDEFAULT_DIALOG_STYLE)
		self.panel = wxPanel(self, wxNewId())
		wxStaticText(self.panel, wxNewId(), "Slideshow Files:", wxPoint(50, 5))
		fbox =	wxStaticBox(self.panel, wxNewId(), "", wxPoint(10, 15), wxSize(W/4 + 40, H*0.6 + 25))
		self.filelist = wxListCtrl(fbox, wxNewId(), wxPoint(10, 15), wxSize(W/4 + 20, H*0.6 + 2), wxLC_LIST)
		
		bw = W/4 + 60
		## # Buttons for the file list box
		diffh = H*0.12
		deltah = 10
		pid = wxNewId()
		#Play button
		self.play = wxButton(self.panel, pid, "	 Play  ", wxPoint(bw, 30))
		EVT_BUTTON(self, pid, self.StartShow)
		#Close button
		cid = wxNewId()
		self.close=wxButton(self.panel, cid, "	Close  ", wxPoint(bw, deltah+diffh))
		EVT_BUTTON(self, cid, self.EndShow)
		#Add button
		aid = wxNewId()
		self.add = wxButton(self.panel, aid, "	Add	 ", wxPoint(bw, deltah+2*diffh))
		EVT_BUTTON(self, aid, self.AddFiles)
		#Add all button
		aaid = wxNewId()
		self.aadd = wxButton(self.panel, aaid, "  Add All  ", wxPoint(bw, deltah+3*diffh))
		EVT_BUTTON(self, aaid, self.AddAllFiles)
		#Remove button
		rid = wxNewId()
		self.rm = wxButton(self.panel, rid, "  Remove  ", wxPoint(bw, deltah+4*diffh))
		EVT_BUTTON(self, rid, self.RemoveFiles)
		#Remove All button
		raid = wxNewId()
		self.rmall = wxButton(self.panel, raid, "  Remove All  ", wxPoint(bw, deltah+5*diffh))
		EVT_BUTTON(self, raid, self.RemoveAllFiles)
		# File selection window
		self.fdlg = wxGenericFileCtrl()
		#wxFileDialog(self.panel, "Pick Files", "", "", "*.*", 0, wxPoint(bw + 20, 5))
		self.fdlg.ShowModal()
		
		self.panel.Fit()
		#self.Fit()
		self.Show(true)

	def StartShow(self,event):
		pass

	def EndShow(self,event):
		pass

	def AddFiles(self,event):
		pass

	def AddAllFiles(self,event):
		pass

	def RemoveFiles(self,event):
		pass

	def RemoveAllFiles(self,event):
		pass

class pyWiewSlideThread(threading.Thread):
	"""Thread subclass to perform slideshows"""

	#This class is used to do a slideshow of images
	
	def __init__(self, name, func, parent, args):
		threading.Thread.__init__(self, None, func, name)
		#flag to stop slideshow (to be set from outside)
		self._flag = 0
		#function to call
		self._func = func
		#frame where pic is drawn
		self._frame = parent
		#slideshow gap
		self._gap = args[0]
		#whether to loop slideshow
		self._loop = args[1]
		 

	def	 run(self):
		"Run the slideshow thread"
		
		stindex = self._frame.GetFileIndex()
		currindex=0

		while self._flag==0:
			time.sleep(self._gap)
			if self._flag:
				break
			try:
                #wxMutexGuiEnter()
				self._func(None)
                #wxMutexGuiLeave()
			except IOError, (errno, strerror):
				msg = self._frame._fileName + ': ' + 'IOError: ' + str(errno) + ' ' + strerror
				wxLogMessage(msg)
			  
			currindex = self._frame.GetFileIndex()
			#condition for breaking loop
			#if we dont need to loop
			if not self._loop:
				#we have completed a round
				#so break
				if currindex == stindex:
					break
				
	def	 Terminate(self):
		"To be called from outside to end thread"
		
		self._flag = 1


